function varargout = MultiDeviceSample(varargin)
% MULTIDEVICESAMPLE MATLAB code for MultiDeviceSample.fig
%      MULTIDEVICESAMPLE, by itself, creates a new MULTIDEVICESAMPLE or raises the existing
%      singleton*.
%
%      H = MULTIDEVICESAMPLE returns the handle to a new MULTIDEVICESAMPLE or the handle to
%      the existing singleton*.
%
%      MULTIDEVICESAMPLE('CALLBACK',hObject,eventData,handles,...) calls the local
%      function named CALLBACK in MULTIDEVICESAMPLE.M with the given input arguments.
%
%      MULTIDEVICESAMPLE('Property','Value',...) creates a new MULTIDEVICESAMPLE or raises the
%      existing singleton*.  Starting from the left, property value pairs are
%      applied to the GUI before MultiDeviceSample_OpeningFcn gets called.  An
%      unrecognized property name or invalid value makes property application
%      stop.  All inputs are passed to MultiDeviceSample_OpeningFcn via varargin.
%
%      *See GUI Options on GUIDE's Tools menu.  Choose "GUI allows only one
%      instance to run (singleton)".
%
% See also: GUIDE, GUIDATA, GUIHANDLES

% Edit the above text to modify the response to help MultiDeviceSample

% Last Modified by GUIDE v2.5 27-Nov-2013 17:04:24

% Begin initialization code - DO NOT EDIT
gui_Singleton = 1;
gui_State = struct('gui_Name',       mfilename, ...
                   'gui_Singleton',  gui_Singleton, ...
                   'gui_OpeningFcn', @MultiDeviceSample_OpeningFcn, ...
                   'gui_OutputFcn',  @MultiDeviceSample_OutputFcn, ...
                   'gui_LayoutFcn',  [] , ...
                   'gui_Callback',   []);
if nargin && ischar(varargin{1})
    gui_State.gui_Callback = str2func(varargin{1});
end

if nargout
    [varargout{1:nargout}] = gui_mainfcn(gui_State, varargin{:});
else
    gui_mainfcn(gui_State, varargin{:});
end
% End initialization code - DO NOT EDIT


% --- Executes just before MultiDeviceSample is made visible.
function MultiDeviceSample_OpeningFcn(hObject, eventdata, handles, varargin)
% This function has no output args, see OutputFcn.
% hObject    handle to figure
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)
% varargin   command line arguments to MultiDeviceSample (see VARARGIN)
global g;

% Choose default command line output for MultiDeviceSample
handles.output = hObject;

g = load('PDC_DEV_VALUE.mat');

try
    [ret errorCode] = PDC_Init;
    if ret == g.PDC_FAILED
        error('PDC_Init Error : %d', errorCode);
    end

    ipList = [uint32(hex2dec('C0A8000A')), uint32(hex2dec('C0A8000B'))]; % Camera IP Address 192.168.0.10 & 192.168.0.11

    [ret, detectNumInfo, errorCode] = PDC_DetectDevice(g.PDC_INTTYPE_G_ETHER, ipList, 2, 0);
    if ret == g.PDC_FAILED
        error('PDC_DetectDevice Error : %d', errorCode);
    end

    if detectNumInfo.m_nDeviceNum < 2
        error('DetectNumInfo.m_nDeviceNum Error : DetectNumInfo.m_nDeviceNum = %d', detectNumInfo.m_nDeviceNum);
    end

    for i = 1:detectNumInfo.m_nDeviceNum
        [ret, deviceNo, errorCode ] = PDC_OpenDevice(detectNumInfo.m_DetectInfo(i));
        if ret == g.PDC_FAILED
            error('PDC_OpenDevice Error : %d', errorCode);
        end
        
        childNo = 1;
        
        [ret, mode, errorCode] = PDC_GetColorType(deviceNo, childNo);
        if ret == g.PDC_FAILED
            error('PDC_GetColorType Error : %d', errorCode);
        end
    
        handles.colorType(i) = mode;

        if mode == g.PDC_COLORTYPE_COLOR
            [ret, bitSel, ~, ~, errorCode] = PDC_GetTransferOption(deviceNo, childNo);
            if ret == g.PDC_FAILED
                error('PDC_GetTransferOption Error : %d', errorCode);
            end

            [ret, errorCode] = PDC_SetTransferOption(deviceNo, childNo, bitSel, g.PDC_FUNCTION_OFF, g.PDC_COLORDATA_INTERLEAVE_RGB); 
            if ret == g.PDC_FAILED
                error('PDC_SetTransferOption Error : %d', errorCode);
            end
        end
        
        handles.deviceNo(i) = deviceNo;
        handles.childNo(i) = childNo;
    end
    
    handles.numberOfDevice = detectNumInfo.m_nDeviceNum;
    
    handles.liveTimer = timer('TimerFcn', {@LiveFcn, hObject}, 'Period', 0.001, 'ExecutionMode', 'fixedSpacing');

    % Update handles structure
    guidata(hObject, handles);
    
    start(handles.liveTimer);
    
    % UIWAIT makes RecordDuringSaveSample wait for user response (see UIRESUME)
    uiwait(handles.figure1);
catch exception
    h = errordlg(exception.message, 'Multi Device Sample');
    uiwait(h);
    close;
end


function LiveFcn(~, ~, hFigure)
% hFigure    handle to figure

global g; % PDC_DEV_VALUE

handles = guidata(hFigure);

try
    for i = 1:min(handles.numberOfDevice, 2)
        if i == 1
            frame = handles.axes1;
        else
            frame = handles.axes2;
        end
        
        [ret, width, height, errorCode] = PDC_GetResolution(handles.deviceNo(i), handles.childNo(i));
        if ret == g.PDC_FAILED
            error('PDC_GetResolution Error : %d', errorCode);
        end

        if handles.colorType(i) == g.PDC_COLORTYPE_MONO
            [ret, data, errorCode] = PDC_GetLiveImageData(handles.deviceNo(i), handles.childNo(i), 8, g.PDC_COLORTYPE_MONO, g.PDC_FUNCTION_OFF, width, height);
            if ret == g.PDC_FAILED
                error('PDC_GetLiveImageData Error : %d', errorCode);
            end

            colormap(frame, gray(256));
            image(data.', 'Parent', frame);
        else
            [ret, data, errorCode] = PDC_GetLiveImageData(handles.deviceNo(i), handles.childNo(i), 8, g.PDC_COLORTYPE_COLOR, g.PDC_FUNCTION_OFF, width, height);
            if ret == g.PDC_FAILED
                error('PDC_GetLiveImageData Error : %d', errorCode);
            end

            data = permute(data,[3 2 1]);

            image(data, 'Parent', frame);
        end

        set(frame, 'Visible', 'off');
    end
catch exception
    h = errordlg(exception.message, 'Multi Device Sample');
    uiwait(h);
end

guidata(handles.output, handles);

drawnow;

% --- Outputs from this function are returned to the command line.
function varargout = MultiDeviceSample_OutputFcn(hObject, eventdata, handles) 
% varargout  cell array for returning output args (see VARARGOUT);
% hObject    handle to figure
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Get default command line output from handles structure
% varargout{1} = handles.output;


% --- Executes when user attempts to close figure1.
function figure1_CloseRequestFcn(hObject, eventdata, handles)
% hObject    handle to figure1 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

if isfield(handles, 'liveTimer')
    stop(handles.liveTimer);
    delete(handles.liveTimer);
end

% Hint: delete(hObject) closes the figure
delete(hObject);

clear mex;
