/*=================================================================
* PDC_SaveCihxFromFile.cpp
*=================================================================*/

#include	"mex.h"
#include	<windows.h>
#include    <string.h>
#include	"PDCLIB.h"

void mexFunction( int nlhs, mxArray *plhs[], int nrhs, const mxArray *prhs[] )
{    
    PDC_ARCHIVE_HANDLE pHandle;
    unsigned long* pRet;    
    unsigned long* pErrorCode;
    char* pSource;
    char* pPath;
	PDC_ARCHIVE_PARAM pRequired;
    PDC_ARCHIVE_OPTION option;
	unsigned long optionCount;
    unsigned long tmpHandle;
    unsigned long buflen;
    PDC_ARCHIVE_OPTION_META *pMetaOption;
    mxArray* tmpOption;
    unsigned long tmpType;
    
    plhs[ 0 ]   = mxCreateNumericMatrix( 1, 1, mxUINT32_CLASS, mxREAL );
    plhs[ 1 ]   = mxCreateNumericMatrix( 1, 1, mxUINT32_CLASS, mxREAL );
     
    tmpHandle = ( unsigned long )mxGetScalar( prhs[ 0 ] );
    pHandle = ( PDC_ARCHIVE_HANDLE )tmpHandle;
    
    buflen = 256;
    
    pSource	= ( char * )malloc( sizeof( char )*buflen );  
	mxGetString( prhs[ 1 ],  pSource, buflen );
    
	pPath	= ( char * )malloc( sizeof( char )*buflen );  
	mxGetString( prhs[ 2 ],  pPath, buflen );
    
    pRequired.pFileFormat = ( char * )malloc( sizeof( char )*buflen );  
	mxGetString(mxGetFieldByNumber(prhs[ 3 ], 0, 0), ( char *)pRequired.pFileFormat, buflen);
    
    pRequired.pColorType  = ( char * )malloc( sizeof( char )*buflen );  
	mxGetString(mxGetFieldByNumber(prhs[ 3 ], 0, 1), ( char *)pRequired.pColorType, buflen);

    pRequired.colorDepth  = ( unsigned long )mxGetScalar( mxGetFieldByNumber( prhs[ 3 ], 0, mxGetFieldNumber( prhs[ 3 ],"colorDepth" ) ) );
  
    tmpType = ( unsigned long )mxGetScalar( mxGetFieldByNumber( prhs[ 4 ], 0, mxGetFieldNumber( prhs[ 4 ],"type" ) ) );
    option.type    = ( PDC_ARCHIVE_OPTION_TYPE )tmpType;
    option.count   = ( unsigned long )mxGetScalar( mxGetFieldByNumber( prhs[ 4 ], 0, mxGetFieldNumber( prhs[ 4 ],"count" ) ) );
   
    pMetaOption = (PDC_ARCHIVE_OPTION_META*)malloc(sizeof(PDC_ARCHIVE_OPTION_META) * option.count);
    
    tmpOption = mxGetFieldByNumber(prhs[ 4 ], 0, mxGetFieldNumber( prhs[ 4 ],"option" ));
    
    for(int i = 0; i < option.count; ++i)
    {
        pMetaOption[i].pKey   = ( char * )malloc( sizeof( char )*buflen ); 
        mxGetString(mxGetFieldByNumber(tmpOption, i, 0), ( char *)pMetaOption[i].pKey, buflen);
  
        pMetaOption[i].pValue =  ( char * )malloc( sizeof( char )*buflen );  
	    mxGetString(mxGetFieldByNumber(tmpOption, i, 1), ( char *)pMetaOption[i].pValue, buflen);
    }
    
    option.pOption = pMetaOption;
    
    optionCount = ( unsigned long )mxGetScalar( prhs[ 5 ] );
    
    pRet        = ( unsigned long * )mxGetPr( plhs[ 0 ] ); 
    pErrorCode	= ( unsigned long * )mxGetPr( plhs[ 1 ] );
     
    *pRet		= PDC_SaveCihxFromFile(pHandle, pSource, pPath, &pRequired, &option, optionCount, pErrorCode );
}
