/*==============================================================================
* PDC_RAWFileLoad.c
*==============================================================================*/
#include	"mex.h"
#include	<windows.h>
#include	"PDCLIB.h"

void mexFunction( int nlhs, mxArray *plhs[], int nrhs, const mxArray *prhs[] )
{
    LPCTSTR lpszFileName;
 	int buflen;
 	PDC_IMAGE_BUFF_INFO info;
    unsigned long nMRawBitDepth;
    unsigned long *pErrorCode;
    unsigned long *pRet;
    void *pBuff;
	mxClassID classID;
	int dims;
	int dims_mono[2];
	int dims_color[3];

 	buflen			= mxGetM( prhs[ 0 ] ) * mxGetN( prhs[ 0 ] ) * sizeof( mxChar ) + 1;
	lpszFileName	= ( LPCTSTR )malloc( sizeof( LPCTSTR )*buflen );  

   
	mxGetString( prhs[ 0 ],  lpszFileName, buflen );
	info.m_nWidth   = ( long )mxGetScalar( mxGetFieldByNumber( prhs[ 1 ], 0, mxGetFieldNumber( prhs[ 1 ],"m_nWidth" ) ) );
	info.m_nHeight  = ( long )mxGetScalar( mxGetFieldByNumber( prhs[ 1 ], 0, mxGetFieldNumber( prhs[ 1 ],"m_nHeight" ) ) );
	info.m_nBytePerLine = ( long )mxGetScalar( mxGetFieldByNumber( prhs[ 1 ], 0, mxGetFieldNumber( prhs[ 1 ],"m_nBytePerLine" ) ) );
	info.m_nRealBitPerPixel = ( unsigned short )mxGetScalar( mxGetFieldByNumber( prhs[ 1 ], 0, mxGetFieldNumber( prhs[ 1 ],"m_nRealBitPerPixel" ) ) );
	info.m_nInterleave  = ( long )mxGetScalar( mxGetFieldByNumber( prhs[ 1 ], 0, mxGetFieldNumber( prhs[ 1 ],"m_nInterleave" ) ) );
    nMRawBitDepth       = ( long )mxGetScalar( prhs[ 2 ] );

   
	dims_mono[0]    = info.m_nWidth;
	dims_mono[1]    = info.m_nHeight;
	dims_color[0]   = 3;
	dims_color[1]   = info.m_nWidth;
	dims_color[2]   = info.m_nHeight;

	classID = (nMRawBitDepth == PDC_RAW_BITDEPTH_8) ? mxUINT8_CLASS : mxUINT16_CLASS;
	dims = (info.m_nInterleave == PDC_COLORDATA_NOCOLOR) ? 2 : 3;

    plhs[ 0 ]		= mxCreateNumericMatrix( 1, 1, mxUINT32_CLASS, mxREAL );
	plhs[ 1 ]       = mxCreateNumericArray( dims, (dims == 2) ? dims_mono : dims_color, classID, mxREAL );
    plhs[ 2 ]		= mxCreateNumericMatrix( 1, 1, mxUINT32_CLASS, mxREAL );

    pRet            = ( unsigned long * )mxGetPr( plhs[ 0 ] );
    pBuff           = ( void *)mxGetPr( plhs[ 1 ] );
    pErrorCode      = ( unsigned long * )mxGetPr( plhs[ 2 ] );
        
	*pRet		    = PDC_RAWFileLoad( lpszFileName, &info, nMRawBitDepth, pBuff, pErrorCode );
}

